=== debian/changelog ===
seqan3 (3.4.0~rc.3+ds-4) unstable; urgency=medium

  * d/control: skip building on 32-bit architectures, they are not
    supported. Closes: #1103097

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 23 Apr 2025 15:22:40 +0200

seqan3 (3.4.0~rc.3+ds-3) unstable; urgency=medium

  * d/control: mark that this new version breaks the autopkgtests in
    older seqan-raptor packages.
  * d/control: upgrade Standards-Version to 4.7.0

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 12 Feb 2025 10:42:19 +0100

seqan3 (3.4.0~rc.3+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 11 Feb 2025 16:46:22 +0100

seqan3 (3.4.0~rc.3+ds-1) experimental; urgency=medium

  * Team upload.
  * New upstream version. Closes: #1093357
  * d/patches: remove forwarded patches
  * d/rules: remove use of the now-deprecated gold linker

 -- Enrico Seiler <enrico.seiler.debian@outlook.com>  Wed, 22 Jan 2025 14:28:42 +0100

seqan3 (3.4.0~rc.2+ds-1) experimental; urgency=medium

  * Team upload.
  * New upstream version
  * refresh patches
  * d/control, d/tests: remove superfluous dependencies
  * d/patches: remove external sources for documentation
  * d/patches: add patches from upstream
  * d/install: update paths
  * d/rules: update
  * d/tests: update
  * d/copyright: update paths
  * d/rules: delete cereal
  * d/rules: update for salsa ci
  * d/salsa-ci: disable i386

 -- Enrico Seiler <enrico.seiler.debian@outlook.com>  Sat, 14 Dec 2024 03:02:27 +0100

seqan3 (3.3.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Fix parallel tests. Closes: #1087373.

 -- Santiago Vila <sanvila@debian.org>  Wed, 13 Nov 2024 23:55:00 +0100
